import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

int WIDTH = 896;
int HEIGHT = 640;
int tile_size = 64;

Player player;
Tilemap tilemap;
Minim minim;
AudioPlayer song;
AudioSample jump;
AudioSample pickup;
AudioSample enter;

PImage darkmatter;
int score;
int deaths;
boolean gameOver = false;
public boolean[] keys;

void setup() {
  size(WIDTH, HEIGHT);
  minim = new Minim(this);
  song = minim.loadFile("Desert.mp3");
  jump = minim.loadSample("Jump.wav");
  jump.setGain(-11);
  pickup = minim.loadSample("Pickup.wav");
  enter = minim.loadSample("EnterPortal.wav");
  song.play();
  song.loop();
  player = new Player();
  tilemap = new Tilemap(WIDTH, HEIGHT, tile_size);
  keys = new boolean[4];
  darkmatter = loadImage("DarkMatter.png");
  score = 0;
  deaths = 0;
}


void draw() {
  if(gameOver == false) {
    update();
    render();
  } else {
    background(0);
    textSize(16);
    fill(255);
    text("Thank you for playing!", 364,320);
  }
}

void update() {
  player.update();
  println("X: " + int(player.x+WIDTH/2-player.player_size/2) + " Y: " + int(player.y+HEIGHT/2-player.player_size/2));
}

void render() {
  tilemap.render();
}

void keyPressed() {
  if(keyCode == UP) keys[3] = true;
  if(keyCode == LEFT) keys[1] = true;
  if(keyCode == RIGHT) keys[2] = true;
  if(keyCode == DOWN) keys[0] = true;
}

void keyReleased() {
  if(keyCode == UP) keys[3] = false;
  if(keyCode == LEFT) keys[1] = false;
  if(keyCode == RIGHT) keys[2] = false;
  if(keyCode == DOWN) keys[0] = false;
}
