public class Map {
  int map_w;
  int map_h;
  int level;
  int map[][];
  int spawnX, spawnY;
  int totalPoints;
  Portal portal;
  ArrayList<Pickup> pickups;
  color[] colors = {
    #4CFF00, #7F3300, #267F00, #542709, #303030, #A0A0A0
  };
  PImage levelImage;
  public Map(int level) {
    this.level = level;
    levelImage = loadImage("levels/"+level+".png");
    this.map_w = levelImage.width;
    this.map_h = levelImage.height;
    this.map = new int[map_w][map_h];
    pickups = new ArrayList<Pickup>();
    for (int x = 0; x < map_w; x++) {
      for (int y = 0; y < map_h; y++) {
        color pixel = levelImage.get(x, y);
        boolean choose = false;
        for (int i = 0; i < colors.length; i++) {
          //println("C1: " + pixel + " C2: " + colors[i]);
          if (choose == false) {
            if (pixel == colors[i]) {
              choose = true;
              map[x][y] = i;
            } else {
              map[x][y] = -1;
            }
          }
        }
        if(pixel == color(0)) pickups.add(new Pickup(x*tile_size, y*tile_size));
        if(pixel == color(255,0,0)) {
          spawnX = x;
          spawnY = y;
        }
        if(pixel == color(0,0,255)) {
          portal = new Portal(x*tile_size-tile_size, y*tile_size-tile_size);
        }
      }
    }
    totalPoints = pickups.size();
  }
}

